package initialize

import (
	"gitea.pena/PenaSide/common/encrypt"
	"github.com/caarlos0/env/v8"
	"github.com/joho/godotenv"
	"log"
)

type Config struct {
	ClientHttpURL               string `env:"CLIENT_HTTP_URL" envDefault:"10.8.0.18:1492"`
	PostgresURL                 string `env:"POSTGRES_URL" envDefault:"host=localhost port=35432 user=squiz password=Redalert2 dbname=squiz sslmode=disable"`
	KafkaBrokers                string `env:"KAFKA_BROKERS" envDefault:"localhost:9092"`
	KafkaTopicQueueBitrix       string `env:"KAFKA_TOPIC_QUEUE_BITRIX" envDefault:"test-topic"`
	KafkaGroup                  string `env:"KAFKA_GROUP" envDefault:"bitrixCRM"`
	RedisHost                   string `env:"REDIS_HOST" envDefault:"localhost:6379"`
	RedisPassword               string `env:"REDIS_PASSWORD" envDefault:"admin"`
	RedisDB                     int    `env:"REDIS_DB" envDefault:"2"`
	BitrixIntegrationID         string `env:"BITRIX_INTEGRATION_ID" envDefault:"app.670bd825e44c52.61826940"` // код интеграции
	QuizIntegrationsRedirectURL string `env:"QUIZ_INTEGRATIONS_REDIRECT_URL" envDefault:"https://squiz.pena.digital/integrations"`
	// секрет интеграции
	BitrixIntegrationSecret string `env:"BITRIX_INTEGRATION_SECRET" envDefault:"Ki0MElZXS6dE6tRsGxixri2jmxbxF2Xa4qQpBPziGdAvvLAHJx"`
	// урл на который будет возвращен пользователь после авторизации это webhook/create get
	OauthReturnURL string `env:"OAUTH_RETURN_URL" envDefault:"https://squiz.pena.digital/squiz/amocrm/oauth"`
	ExternalCfg    ExternalCfg
}

type ExternalCfg struct {
	// публичный и приватные ключи для енкрипта и декрипта стейта который передаем в битрикс а потом он приходит
	EncryptCommon encrypt.Encrypt
}

func LoadConfig() (*Config, error) {
	if err := godotenv.Load(); err != nil {
		log.Print("No .env file found")
	}
	var config Config
	if err := env.Parse(&config); err != nil {
		return nil, err
	}
	return &config, nil
}
