package models

import "penahub.gitlab.yandexcloud.net/backend/quiz/common.git/model"

type KafkaMessage struct {
	AccountID  string
	AuthCode   string
	RefererURL string
	MemberID   string
	Type       MessageType
	Rule       KafkaRule
}

type KafkaRule struct {
	QuizID      int32
	PerformerID string // айдишник ответственного за сделку
	PipelineID  int32  // айдишник воронки
	TypeID      string // шаг сделки только с "ENTITY_ID":"DEAL_TYPE","STATUS_ID":"SALE"
	StageID     string // стадия сделки,  шаг "ENTITY_ID":"DEAL_STAGE","STATUS_ID":"NEW"
	SourceID    string // тип источника, шаг "ENTITY_ID":"SOURCE","STATUS_ID":"CALL"
	LeadFlag    bool   // флаг показывающий на то что нужен лид а не дил
	FieldsRule  model.BitrixFieldRules
	StatusID    string
}

type MessageType string

const (
	UsersUpdate     MessageType = "users"
	PipelinesUpdate MessageType = "pipelines"
	FieldsUpdate    MessageType = "fields"
	TagsUpdate      MessageType = "tags"
	UserCreate      MessageType = "userCreate"
	AllDataUpdate   MessageType = "allDataUpdate"
	RuleCheck       MessageType = "ruleCheck"
	UserReLogin     MessageType = "userReLogin"
	StepsUpdate     MessageType = "steps"
)
