package service

import (
	"gitea.pena/PenaSide/common/encrypt"
	"go.uber.org/zap"
	"penahub.gitlab.yandexcloud.net/backend/quiz/bitrix/internal/brokers"
	"penahub.gitlab.yandexcloud.net/backend/quiz/bitrix/internal/initialize"
	"penahub.gitlab.yandexcloud.net/backend/quiz/bitrix/pkg/bitrixClient"
	"penahub.gitlab.yandexcloud.net/backend/quiz/common.git/dal"
)

type Deps struct {
	Repository   *dal.BitrixDal
	Logger       *zap.Logger
	BitrixClient *bitrixClient.Bitrix
	Producer     *brokers.Producer
	Config       initialize.Config
	Encrypt      *encrypt.Encrypt
}

type Service struct {
	repository   *dal.BitrixDal
	logger       *zap.Logger
	bitrixClient *bitrixClient.Bitrix
	producer     *brokers.Producer
	config       initialize.Config
	encrypt      *encrypt.Encrypt
}

func NewService(deps Deps) *Service {
	return &Service{
		repository:   deps.Repository,
		logger:       deps.Logger,
		bitrixClient: deps.BitrixClient,
		producer:     deps.Producer,
		config:       deps.Config,
		encrypt:      deps.Encrypt,
	}
}
