package tools

import (
	"penahub.gitlab.yandexcloud.net/backend/quiz/common.git/model"
)

func ValidateUtmFields(response *model.UserListBitrixFieldsResp) *model.UserListBitrixFieldsResp {
	checkUTM := map[string]struct{}{
		"utm_content":       {},
		"utm_medium":        {},
		"utm_campaign":      {},
		"utm_source":        {},
		"utm_term":          {},
		"utm_referrer":      {},
		"roistat":           {},
		"referrer":          {},
		"openstat_service":  {},
		"openstat_campaign": {},
		"openstat_ad":       {},
		"openstat_source":   {},
		"from":              {},
		"gclientid":         {},
		"_ym_uid":           {},
		"_ym_counter":       {},
		"gclid":             {},
		"yclid":             {},
		"fbclid":            {},
	}

	data := &model.UserListBitrixFieldsResp{
		Count: response.Count,
		Items: []model.BitrixField{},
	}

	for _, r := range response.Items {
		if _, ok := checkUTM[r.EditFromLabel]; !ok {
			data.Items = append(data.Items, r)
		}
	}

	return data
}
